(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react-form-with-constraints')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react-form-with-constraints'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactFormWithConstraintsBootstrap = {}, global.ReactFormWithConstraints));
})(this, (function (exports, reactFormWithConstraints) { 'use strict';

  // ## Error
  //
  // - Bootstrap 5 "input.form-control.is-invalid":
  // https://getbootstrap.com/docs/5.0/forms/validation/#server-side
  //
  // ## Warning
  //
  // - Bootstrap >= 4: not available
  //
  // - Bootstrap v4.0.0-alpha.6 "input.form-control.form-control-warning":
  // https://v4-alpha.getbootstrap.com/components/forms/#validation
  // https://github.com/twbs/bootstrap/blob/v4.0.0-alpha.6/scss/_forms.scss#L254
  //
  // - Bootstrap 3 "div.form-group.has-warning":
  // https://getbootstrap.com/docs/3.3/css/#forms-control-validation
  // https://github.com/twbs/bootstrap/blob/v3.3.7/less/forms.less#L431
  //
  // - Bootstrap 2 "div.control-group.warning":
  // https://getbootstrap.com/2.3.2/base-css.html#forms
  // https://github.com/twbs/bootstrap/blob/v2.3.2/less/forms.less#L347
  //
  // ## Info
  //
  // - Bootstrap >= 3: not available
  //
  // - Bootstrap 2 "div.control-group.info":
  // https://getbootstrap.com/2.3.2/base-css.html#forms
  // https://github.com/twbs/bootstrap/blob/v2.3.2/less/forms.less#L347
  //
  // ## WhenValid
  //
  // - Bootstrap 5 "input.form-control.is-valid":
  // https://getbootstrap.com/docs/5.0/forms/validation/#server-side
  class FieldFeedback extends reactFormWithConstraints.FieldFeedback {
  }
  FieldFeedback.defaultProps = {
      // https://github.com/facebook/react/issues/3725#issuecomment-169163998
      // [React.Component.defaultProps objects are overridden, not merged?](https://stackoverflow.com/q/40428847)
      ...reactFormWithConstraints.FieldFeedback.defaultProps,
      classes: {
          error: 'invalid-feedback',
          warning: 'warning-feedback',
          info: 'info-feedback',
          whenValid: 'valid-feedback'
      }
  };
  class FieldFeedbackTooltip extends reactFormWithConstraints.FieldFeedback {
  }
  FieldFeedbackTooltip.defaultProps = {
      // https://github.com/facebook/react/issues/3725#issuecomment-169163998
      // [React.Component.defaultProps objects are overridden, not merged?](https://stackoverflow.com/q/40428847)
      ...reactFormWithConstraints.FieldFeedback.defaultProps,
      classes: {
          error: 'invalid-tooltip',
          warning: 'warning-tooltip',
          info: 'info-tooltip',
          whenValid: 'valid-tooltip'
      }
  };
  class Input extends reactFormWithConstraints.Input {
  }
  Input.defaultProps = {
      classes: {
          isPending: 'is-pending',
          hasErrors: 'is-invalid',
          hasWarnings: 'is-warning',
          hasInfos: 'is-info',
          isValid: 'is-valid'
      }
  };

  Object.defineProperty(exports, 'Async', {
    enumerable: true,
    get: function () { return reactFormWithConstraints.Async; }
  });
  Object.defineProperty(exports, 'FieldFeedbacks', {
    enumerable: true,
    get: function () { return reactFormWithConstraints.FieldFeedbacks; }
  });
  Object.defineProperty(exports, 'FormWithConstraints', {
    enumerable: true,
    get: function () { return reactFormWithConstraints.FormWithConstraints; }
  });
  exports.FieldFeedback = FieldFeedback;
  exports.FieldFeedbackTooltip = FieldFeedbackTooltip;
  exports.Input = Input;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
